This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours

Bug 894585

Summary: Review Request: coin-or-CoinUtils - Coin-or Utilities
Product: [Fedora] Fedora Reporter: Paulo Andrade <paulo.cesar.pereira.de.andrade>
Component: Package ReviewAssignee: Jerry James <loganjerry>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: loganjerry, notting, package-review
Target Milestone: ---Flags: loganjerry: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-04-26 20:02:19 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On: 894610    
Bug Blocks: 894586, 894587, 894588, 894589, 894591, 894593, 894594, 894596, 894597, 894598, 894599, 894600, 894602, 894603, 894605, 894606, 894608, 894609    

Description Paulo Andrade 2013-01-12 08:58:03 EST
Spec URL: http://pcpa.fedorapeople.org/coin-or/coin-or-CoinUtils.spec
SRPM URL: http://pcpa.fedorapeople.org/coin-or/coin-or-CoinUtils-2.8.7-3.fc19.src.rpm
Description: CoinUtils (Coin-or Utilities) is an open-source collection of classes
and functions that are generally useful to more than one COIN-OR project.
These utilities include:

  * Vector classes
  * Matrix classes
  * MPS file reading
  * Comparing floating point numbers with a tolerance
Fedora Account System Username: pcpa
Comment 1 Paulo Andrade 2013-01-12 08:59:37 EST
Note that the tarball is remade due to:
+ Data files without a clean license. licensecheck does not trigger
  it because they are small test case files, but a not so small
  collection, and authorship information was lost.
+ ThirdParty directory, that points to, but has no contents, of
  non free code (usually source code open but needs some kind of
  paid license to be able to use).
+ Most coin-or projects bundle other coin-or projects that are
  dependencies. If tarballs are not repackaged, %build will remove
  the bundled dependencies.

I made the original package back in september and was talking from
time to time to upstream about the issues above. There should be
at some point in the near future a new release with bundled dependencies
and code that cannot be redistributed removed from tarballs. There is
also a way to get "clean" tarballs from coin-or trac, but for the
review request I did choose the most common method in Fedora for
these conditions.
Comment 2 Paulo Andrade 2013-01-14 15:46:55 EST
Update:

- Add coin-or-Sample to build requires (#894610#c4).
- Update to latest upstream release.

Spec URL: http://pcpa.fedorapeople.org/coin-or/coin-or-CoinUtils.spec
SRPM URL: http://pcpa.fedorapeople.org/coin-or/coin-or-CoinUtils-2.8.8-1.fc19.src.rpm
Comment 3 Jerry James 2013-04-13 18:05:58 EDT
Issues, in no particular order:
1. The documentation is quite large.  This can be remedied by NOT listing
   graphviz as a BR.  Then dot won't generate the big class diagrams.  I've
   had to do this for several of my packages, as the interaction diagrams grow
   quite large.
2. Version 2.9.0 came out 2 days ago.  (I checked because of the "latest
   version is packaged" question below.)
3. The undefined non-weak symbols reported below indicate that the library
   needs to be linked with -lz -lbz2.
4. The BRs list both atlas-devel, and also blas-devel and lapack-devel.  Since
   atlas is a replacement for the standard blas and lapack, I'm confused.
   Which one are you trying to use?  Also, the final requires don't show
   either, so are any of them really needed at all?

Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Large documentation must go in a -doc subpackage.
  Note: Documentation size is 26152960 bytes in 2206 files.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.

===== SHOULD items =====

Generic:
[x]: Uses parallel make.
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[!]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
     Note: Arch-ed rpms have a total of 28293120 bytes in /usr/share 28272640
     coin-or-CoinUtils-devel-2.8.8-1.fc20.x86_64.rpm 20480 coin-or-
     CoinUtils-2.8.8-1.fc20.x86_64.rpm
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: coin-or-CoinUtils-2.8.8-1.fc20.x86_64.rpm
          coin-or-CoinUtils-devel-2.8.8-1.fc20.x86_64.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint coin-or-CoinUtils coin-or-CoinUtils-devel
coin-or-CoinUtils.x86_64: W: undefined-non-weak-symbol /usr/lib64/libCoinUtils.so.3.8.8 gzopen
coin-or-CoinUtils.x86_64: W: undefined-non-weak-symbol /usr/lib64/libCoinUtils.so.3.8.8 gzclose
coin-or-CoinUtils.x86_64: W: undefined-non-weak-symbol /usr/lib64/libCoinUtils.so.3.8.8 BZ2_bzRead
coin-or-CoinUtils.x86_64: W: undefined-non-weak-symbol /usr/lib64/libCoinUtils.so.3.8.8 gzwrite
coin-or-CoinUtils.x86_64: W: undefined-non-weak-symbol /usr/lib64/libCoinUtils.so.3.8.8 BZ2_bzWriteClose
coin-or-CoinUtils.x86_64: W: undefined-non-weak-symbol /usr/lib64/libCoinUtils.so.3.8.8 BZ2_bzWriteOpen
coin-or-CoinUtils.x86_64: W: undefined-non-weak-symbol /usr/lib64/libCoinUtils.so.3.8.8 BZ2_bzReadOpen
coin-or-CoinUtils.x86_64: W: undefined-non-weak-symbol /usr/lib64/libCoinUtils.so.3.8.8 dgetrf_
coin-or-CoinUtils.x86_64: W: undefined-non-weak-symbol /usr/lib64/libCoinUtils.so.3.8.8 gzread
coin-or-CoinUtils.x86_64: W: undefined-non-weak-symbol /usr/lib64/libCoinUtils.so.3.8.8 dgetrs_
coin-or-CoinUtils.x86_64: W: undefined-non-weak-symbol /usr/lib64/libCoinUtils.so.3.8.8 BZ2_bzWrite
coin-or-CoinUtils.x86_64: W: undefined-non-weak-symbol /usr/lib64/libCoinUtils.so.3.8.8 BZ2_bzReadClose
2 packages and 0 specfiles checked; 0 errors, 12 warnings.
# echo 'rpmlint-done:'



Requires
--------
coin-or-CoinUtils (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.1)(64bit)
    rtld(GNU_HASH)

coin-or-CoinUtils-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    coin-or-CoinUtils(x86-64)
    coin-or-Sample
    libCoinUtils.so.3()(64bit)



Provides
--------
coin-or-CoinUtils:
    coin-or-CoinUtils
    coin-or-CoinUtils(x86-64)
    libCoinUtils.so.3()(64bit)

coin-or-CoinUtils-devel:
    coin-or-CoinUtils-devel
    coin-or-CoinUtils-devel(x86-64)
    pkgconfig(coinutils)



Generated by fedora-review 0.4.0 (660ce56) last change: 2013-01-29
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -b 894585 -m fedora-rawhide-x86_64
Comment 4 Paulo Andrade 2013-04-14 13:40:38 EDT
(In reply to comment #3)

  Jerry, I have been talking with upstream since around september last
year, and was in search of someone to review the packages since early
this year :-) Maybe now it can be done, but at first I only need a
few of them reviewed (5 actually, including CoinUtils), to enable Cbc
in sagemath.
  After significant talk from time to time, upstream made a new,
non official (yet), directory for distribution at:

http://www.coin-or.org/download/pkgsource/

that unlike the tarballs at:

http://www.coin-or.org/download/source/

have the dependencies stripped from the tarball, that is no need
for the %{with_bundle} macro, and also have ThirdParty directories
removed.

> Issues, in no particular order:
> 1. The documentation is quite large.  This can be remedied by NOT listing
>    graphviz as a BR.  Then dot won't generate the big class diagrams.  I've
>    had to do this for several of my packages, as the interaction diagrams
> grow
>    quite large.

  Is it ok to just split out a -doc package? Most users should get it
only as build requires or requires. Either way, I did both, split -doc
and remove graphviz from build requires.

> 2. Version 2.9.0 came out 2 days ago.  (I checked because of the "latest
>    version is packaged" question below.)
> 3. The undefined non-weak symbols reported below indicate that the library
>    needs to be linked with -lz -lbz2.

  Add patch to correct the problem.

> 4. The BRs list both atlas-devel, and also blas-devel and lapack-devel. 
> Since
>    atlas is a replacement for the standard blas and lapack, I'm confused.
>    Which one are you trying to use?  Also, the final requires don't show
>    either, so are any of them really needed at all?

  They are not really required. But configure still checks for them.
It should have been left from my first test packaging of coin-or,
when it did build all bundled dependencies, as this is one of the
first ones to be built. I just removed all blas* build requires.


Update:

- Update to latest upstream release.
- Switch to the new upstream tarballs without bundled dependencies.
- Split documentation in a new subpackage (#894585#3)
- Correct undefined non weak symbols (#894585#3)
- Removed unneeded atlas, blas, glpk and lapack build requires (#894585#3)

Spec URL: http://pcpa.fedorapeople.org/coin-or/coin-or-CoinUtils.spec
SRPM URL: http://pcpa.fedorapeople.org/coin-or/coin-or-CoinUtils-2.9.0-1.fc20.src.rpm
Comment 5 Jerry James 2013-04-15 19:03:55 EDT
OK, that looks good.  This package is APPROVED.
Comment 6 Paulo Andrade 2013-04-15 20:17:11 EDT
New Package SCM Request
=======================
Package Name: coin-or-CoinUtils
Short Description: Coin-or Utilities
Owners: pcpa
Branches: f17 f18 f19
InitialCC:
Comment 7 Jon Ciesla 2013-04-16 09:24:54 EDT
Git done (by process-git-requests).
Comment 8 Fedora Update System 2013-04-16 12:45:22 EDT
coin-or-CoinUtils-2.9.0-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/coin-or-CoinUtils-2.9.0-1.fc19
Comment 9 Fedora Update System 2013-04-16 12:46:27 EDT
coin-or-CoinUtils-2.9.0-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/coin-or-CoinUtils-2.9.0-1.fc18
Comment 10 Fedora Update System 2013-04-17 12:25:24 EDT
coin-or-CoinUtils-2.9.0-1.fc19 has been pushed to the Fedora 19 testing repository.
Comment 11 Fedora Update System 2013-04-26 20:02:31 EDT
coin-or-CoinUtils-2.9.0-1.fc18 has been pushed to the Fedora 18 stable repository.
Comment 12 Fedora Update System 2013-04-26 23:13:12 EDT
coin-or-CoinUtils-2.9.0-1.fc19 has been pushed to the Fedora 19 stable repository.